
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatelessKnowledgeSession;


public class TestQuote {

	 public static void main(String[] args) {
		 TestQuote test = new TestQuote();
		 test.executeRule();
	 }

	 private List<Quote> quotes = new ArrayList<Quote>();

	 public TestQuote(){
		 this.quotes = new ArrayList<Quote>();
		 Quote q1 = new Quote(new BigDecimal("10"));
		 Quote q2 = new Quote(new BigDecimal("20"));
		 Quote q3 = new Quote(new BigDecimal("30"));
		 this.quotes.add(q1);
		 this.quotes.add(q2);
		 this.quotes.add(q3);		 
	 }

	 public void executeRule() {
		 long start = System.currentTimeMillis();
		 final KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		 kbuilder.add(ResourceFactory.newClassPathResource("rule.drl", TestQuote.class), ResourceType.DRL);

		 System.out.println("Adding DRL file in [" + (System.currentTimeMillis() - start) + "]");
			
		 final KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
		 kbase.addKnowledgePackages(kbuilder.getKnowledgePackages());

		 if(kbuilder.hasErrors()) {
			 System.out.println(kbuilder.getErrors().toString());
		 }

		 final StatelessKnowledgeSession ksession = kbase.newStatelessKnowledgeSession();
		 ksession.execute(this.quotes);
	 }

	 public class Quote {
		 private BigDecimal value;

		 public Quote(BigDecimal value) {
			 this.value = value;
		 }

		public BigDecimal getValue() {
			return value;
		}

		public void setValue(BigDecimal value) {
			this.value = value;
		}

	 }
}
